package servlets;

import java.io.IOException;
import java.lang.reflect.Field;
import java.sql.ResultSet;
import java.util.List;
import java.util.Optional;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import db.Database;
import db.DatabaseManager;
import db.annotation.DbTable;
import entity.Ecole;
import entity.Espace;
import entity.Usager;
import entity.Ville;
import microfolie.db.table.EcoleTable;
import microfolie.db.table.EspaceTable;
import microfolie.db.table.UsagerTable;
import microfolie.db.table.VilleTable;

/**
 * Servlet implementation class TestDb
 */
@WebServlet("/TestDb")
public class TestDb extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public TestDb() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		EcoleTable et = EcoleTable.getInstance();
		List<Ecole> le = et.getAll();
		System.out.println("---------------------");
		le.forEach(elt -> System.out.println(elt.libelle + " " + elt.ville.libelle + " " + elt.niveau.libelle));
		
		Ecole e = et.findById(1).get();
		e.libelle = "Lycée " + e.libelle;
		e.ville.libelle = "Maison";
		et.save(e);
		
		et = EcoleTable.getInstance();
		le = et.getAll();
		System.out.println("---------------------");
		le.forEach(elt -> System.out.println(elt.libelle + " " + elt.ville.libelle + " " + elt.niveau.libelle));
		
		VilleTable vt = VilleTable.getInstance();
		Ville v = vt.getById(1);
		System.out.println("---------------------");
		System.out.println(v.libelle);
		
		
		UsagerTable ut = UsagerTable.getInstance();
		Usager u = ut.getById(1);
		System.out.println("---------------------");
		System.out.println(u.prenom);
		System.out.println(u.ville.libelle);
		System.out.println(u.ecole.libelle);
		
		response.getWriter().append("Served at: ").append(request.getContextPath());
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}

}
